Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions

# Triangulator Class Reference

This class can triangulate a convex or concave polygon, even one with holes. More...

List of all members.

## Public Member Functions
| Triangulator ()
| addHoleVertex (int index)
| Adds the next consecutive vertex of the current hole.
| addPolygonVertex (int index)
| Adds the next consecutive vertex of the polygon.
int | addVertex (double x, double y)
| Adds a new vertex to the vertex pool.
int | addVertex (Point2D const point)
| Adds a new vertex to the vertex pool.
| beginHole ()
| Finishes the previous hole, if any, and prepares to add a new hole.
| clear ()
| Removes all vertices and polygon specifications from the Triangulator, and prepares it to start over.
| clearPolygon ()
| Removes the current polygon definition (and its set of holes), but does not clear the vertex pool.
int | getNumTriangles ()
| Returns the number of triangles generated by the previous call to triangulate().
int | getNumVertices ()
| Returns the number of vertices in the pool.
int | getTriangleV0 (int n)
| Returns vertex 0 of the nth triangle generated by the previous call to triangulate().
int | getTriangleV1 (int n)
| Returns vertex 1 of the nth triangle generated by the previous call to triangulate().
int | getTriangleV2 (int n)
| Returns vertex 2 of the nth triangle generated by the previous call to triangulate().
Point2D const | getVertex (int n)
| Returns the nth vertex.
list | getVertices ()
bool | isLeftWinding ()
| Returns true if the polygon vertices are listed in counterclockwise order, or false if they appear to be listed in clockwise order.
| triangulate ()
| Does the work of triangulating the specified polygon.

## Detailed Description

This class can triangulate a convex or concave polygon, even one with holes.

It is adapted from an algorithm published as:

Narkhede A. and Manocha D., Fast polygon triangulation algorithm based on Seidel's Algorithm, UNC-CH, 1994.

http://www.cs.unc.edu/~dm/CODE/GEM/chapter.html

It works strictly on 2-d points. You'll have to convert your polygon into a plane if you have 3-d points.

## Constructor & Destructor Documentation

Triangulator | ( |  | ) |

## Member Function Documentation

addHoleVertex | ( | int | index | ) |

Adds the next consecutive vertex of the current hole.

This vertex should index into the vertex pool established by repeated calls to add_vertex().

The vertices may be listed in either clockwise or counterclockwise order. Vertices should not be repeated.

addPolygonVertex | ( | int | index | ) |

Adds the next consecutive vertex of the polygon.

This vertex should index into the vertex pool established by repeated calls to add_vertex().

The vertices may be listed in either clockwise or counterclockwise order. Vertices should not be repeated. In particular, do not repeat the first vertex at the end.

int addVertex | ( | Point2D const | point | ) |

Adds a new vertex to the vertex pool.

Returns the vertex index number.

int addVertex | ( | double | x,
|  | double | y
| ) |  |

Adds a new vertex to the vertex pool.

Returns the vertex index number.

beginHole | ( |  | ) |

Finishes the previous hole, if any, and prepares to add a new hole.

clear | ( |  | ) |

Removes all vertices and polygon specifications from the Triangulator, and prepares it to start over.

clearPolygon | ( |  | ) |

Removes the current polygon definition (and its set of holes), but does not clear the vertex pool.

int getNumTriangles | ( |  | ) |

Returns the number of triangles generated by the previous call to triangulate().

int getNumVertices | ( |  | ) |

Returns the number of vertices in the pool.

Note that the Triangulator might append new vertices, in addition to those added by the user, if any of the polygon is self-intersecting, or if any of the holes intersect some part of the polygon edges.

int getTriangleV0 | ( | int | n | ) |

Returns vertex 0 of the nth triangle generated by the previous call to triangulate().

This is a zero-based index into the vertices added by repeated calls to add_vertex().

int getTriangleV1 | ( | int | n | ) |

Returns vertex 1 of the nth triangle generated by the previous call to triangulate().

This is a zero-based index into the vertices added by repeated calls to add_vertex().

int getTriangleV2 | ( | int | n | ) |

Returns vertex 2 of the nth triangle generated by the previous call to triangulate().

This is a zero-based index into the vertices added by repeated calls to add_vertex().

Point2D const getVertex | ( | int | n | ) |

Returns the nth vertex.

list getVertices | ( |  | ) |

bool isLeftWinding | ( |  | ) |

Returns true if the polygon vertices are listed in counterclockwise order, or false if they appear to be listed in clockwise order.

triangulate | ( |  | ) |

Does the work of triangulating the specified polygon.

After this call, you may retrieve the new triangles one at a time by iterating through get_triangle_v0/1/2().

All Classes Namespaces Functions Variables Enumerations Enumerator Properties